package com.company.departmentuser.view.department;

import com.company.departmentuser.entity.Department;

import com.company.departmentuser.entity.User;
import com.company.departmentuser.view.main.MainView;

import com.vaadin.flow.component.ClickEvent;
import com.vaadin.flow.router.Route;
import io.jmix.core.DataManager;
import io.jmix.core.EntitySet;
import io.jmix.flowui.kit.component.button.JmixButton;
import io.jmix.flowui.model.CollectionContainer;
import io.jmix.flowui.model.DataContext;
import io.jmix.flowui.model.InstanceContainer;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Objects;
import java.util.Set;

@Route(value = "departments/:id", layout = MainView.class)
@ViewController("Department.detail")
@ViewDescriptor("department-detail-view.xml")
@EditedEntityContainer("departmentDc")
public class DepartmentDetailView extends StandardDetailView<Department> {
    @Autowired
    private DataManager dataManager;
    @ViewComponent
    private CollectionContainer<User> userDc;
    @ViewComponent
    private DataContext dataContext;
    @ViewComponent
    private InstanceContainer<Department> departmentDc;

    @Subscribe(id = "importUsers", subject = "clickListener")

    public void onImportUsersClick(final ClickEvent<JmixButton> event) {
        //Получаю список всех пользователей для импорта
        List<User> usersForImport = dataManager.load(User.class).
                query("select e from User e").list();
        //На всякий случай помещаю userDc в dataContext, но вроде бы он уже отслеживается, так как это свойство department
        dataContext.merge(userDc.getItems());
//Вариант 1 - также не работает
//        userDc.setItems(usersForImport);

//Вариант 2 - пробую добавить хотя бы одного пользователя(не работает)
        User user1 = usersForImport.get(0); // получаю первого пользователя
        //Получаю данный отдел
        Department department = departmentDc.getItem();
        user1.setDepartment(department);//вручную добавляю пользователю Отдел, не знаю надо ли?
        userDc.getMutableItems().add(user1);
        //Здесь могу посмотреть что пользователь добавился для данного отдела
        Set<Object> modified = dataContext.getModified();


        //Если сразу тут и сохранять то видно в возвращаемом значении что user для department не сохранился почему то
        //что-то я делаю не так
        //EntitySet es = dataContext.save();
        System.out.println("Import start");
    }
    
}